#include <cstdio>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <queue>
using namespace std;

typedef struct {
	int x; int l; int k;
} state;

bool operator<(state s1, state s2) {
	return 0;
}

int n,m,t,a,b,l,k;
vector<pair<int,int> > next[101];
int f[101][501][11];

int main() {
	scanf("%d",&t);
	while (t--) {
		scanf("%d %d %d %d %d",&a,&b,&m,&l,&k);
		n=a+b;
		for (int i=1;i<=n;i++) next[i].clear();
		for (int i=0;i<m;i++) {
			int x,y,c;
			scanf("%d %d %d",&x,&y,&c);
			next[x].push_back(make_pair(y,c));
			next[y].push_back(make_pair(x,c));
		}
		memset(f,-1,sizeof(f));
		priority_queue<pair<int,state> > pq;
		pq.push(make_pair(0,(state){n,0,0}));
		f[n][0][0]=0;
		while (!pq.empty()) {
			int d=-pq.top().first;
			state s=pq.top().second;
			pq.pop();
			if (d!=f[s.x][s.l][s.k]) continue;
			for (int i=0;i<next[s.x].size();i++) {
				int y=next[s.x][i].first;
				int len=next[s.x][i].second;
				state s2;
				if (len<=l) {
					if (s.x>a) s2=(state){y,len,s.k+1};
					else if (s.l==0) s2=(state){y,len,s.k+1};
					else {
						s2=(state){y,s.l+len,s.k};
						if (s2.l>l) { s2.k++; s2.l=len; }
					}
					if (s2.k<=k && (d<f[s2.x][s2.l][s2.k] || f[s2.x][s2.l][s2.k]==-1)) {
						f[s2.x][s2.l][s2.k]=d;
						pq.push(make_pair(-d,s2));
					}
				}
				s2=(state){y,0,s.k};
				int d2=d+len;
				if (d2<f[s2.x][s2.l][s2.k] || f[s2.x][s2.l][s2.k]==-1) {
					f[s2.x][s2.l][s2.k]=d2;
					pq.push(make_pair(-d2,s2));
				}
			}
		}
		int rez=1e9;
		for (int len=0;len<=l;len++) for (int jumps=0;jumps<=k;jumps++) {
			if (f[1][len][jumps]!=-1) rez=min(rez,f[1][len][jumps]);
		}
		printf("%d\n",rez);
	}
    return 0;
}
